//____CULEBRA_____X__SDL2_
//SDL/C++
//SETA43


#include <stdio.h>

#include <stdlib.h>

#include <time.h>
#include <SDL2/SDL.h>
#include "SDL2/SDL_ttf.h"
#include "SDL2/SDL_image.h"
#include "SDL2/SDL_mixer.h"

#include "main.h"
#include "ygrafi.h"


char titulo[]="SNAKE SDL2_2023_ xsetaseta@gmail.com\n";

int inkeyM(void);
int waitQuit(void);
void printc(int x, int y, char* temp);
void printn(int x, int y, long temp);
void impri(int x, int y, char c);
char *inputc(int x, int y);
void cls(int r,int g,int b);
void imprixxx(int xi, int yi, int xo, int yo, int w, int h);
void paintSerpiente(void);

void Repaint(void);
void animarMuerte(void);
void animarInicio(void);
void printPanta(void);
void Inicializar(void);

Mix_Chunk *acomer4 = NULL;
Mix_Chunk *aempezar = NULL;
Mix_Chunk *amuerte = NULL;

#define WINDOW_W 25
#define WINDOW_H 19
#define ANCHO_P 1
#define ALTO_P 1
#define TAMA_XY 24   //16x16
#define MAX_SERPIENTE 64
#define SERPIENTE_X 10
#define SERPIENTE_Y 10
#define MANZANA_X 5
#define MANZANA_Y 5
struct Objeto {
    int x;
    int y;
    int w;
    int h;
    int t;
};
struct Objeto Serpiente[MAX_SERPIENTE];
struct Objeto Manzana[1];

#define up 1
#define right 2
#define down 3
#define left 4
#define esquina 5

int cabezaX,cabezaY,longitud;
int Puntos;
int dire;
int tiempo;
unsigned int tiempoX;

#define RETARDO 160
int temporal;


#define SERPI_CA_UP 0,276
#define SERPI_CA_RIGHT 24,276
#define SERPI_CA_DOWN 48,276
#define SERPI_CA_LEFT 72,276

#define SERPI_TR_UP 96,276
#define SERPI_TR_RIGHT 120,276
#define SERPI_TR_DOWN 144,276
#define SERPI_TR_LEFT 168,276

#define SERPI_AN_UP 96,300
#define SERPI_AN_LEFT 120,300
#define SERPI_AN_DOWN 144,300
#define SERPI_AN_RIGHT 168,300

#define SERPI_CO 72,300
#define SERPI_CO_UP 96,324
#define SERPI_CO_LEFT 120,324
#define SERPI_CO_DOWN 144,324
#define SERPI_CO_RIGHT 168,324

#define MANZA_XY 0,300

#define EXPLO_1 24,300
#define EXPLO_2 48,300

#include "puntos.h"
//====================JUEGO=======================

int main (int argc, char *argv[])
{

    int quit = 0;
    int SimbolKey;
    bool fullScreen = false;

    if (init(640,480) == 0 ) return 1;
    //if ( refresco() == -1 ) return 3;
    //Fondo,graficos,fuentes
    if (load_files((char*)"snake0.jpg", (char*)"snake.png", (char*)"setam.ttf") == 0 ) return 2;

    aempezar = Mix_LoadWAV( "aempezar.wav" );
    acomer4=  Mix_LoadWAV( "acomer4.wav" );
    amuerte = Mix_LoadWAV( "amuerte.wav" );

    if(Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024) == -1) //Initialisation de l'API Mixer
        { printf("%s", Mix_GetError());  }
    else
        { printf("OK MIX\n"); }
    Mix_Music *musique;
    musique = Mix_LoadMUS("acule.ogg");

    SDL_ShowCursor(SDL_DISABLE);

    load_puntos();
    
Inicio:
    Inicializar();
    Mix_PlayMusic(musique, -1);
    Mix_RewindMusic();
    printPanta();

    //__________JUEGO___________________________

    while (quit==0)
    {
        SDL_Delay(10);

        while ( SDL_PollEvent( &event ) )
        {
            switch (event.type)
            {
            case  SDL_KEYUP:
                SimbolKey = event.key.keysym.sym;
                break;
            case  SDL_KEYDOWN:
                SimbolKey = event.key.keysym.sym;
                switch (SimbolKey)
                {
                case  SDLK_F1:
                    fullScreen = !fullScreen;
                    if(fullScreen) 
                        { SDL_SetWindowFullscreen(window, SDL_WINDOW_FULLSCREEN);  screen = SDL_GetWindowSurface(window); }
                    else 
                        {  SDL_SetWindowFullscreen(window, 0);  screen = SDL_GetWindowSurface(window); }
                    Repaint();
                    break;
                case  SDLK_ESCAPE:
                    quit = 1;
                    break;
                case SDLK_UP :
                    if(dire!= down)dire = up;
                    break;
                case SDLK_DOWN :
                    if(dire!= up)dire = down;
                    break;
                case SDLK_LEFT :
                    if(dire!= right)dire = left;
                    break;
                case SDLK_RIGHT :
                    if(dire!= left)dire = right;
                    break;
                }

                break;
            case  SDL_QUIT:
                quit = 1;
                break;
            }
        }


        if(SDL_GetTicks()>tiempoX)
        {
            temporal=RETARDO-(tiempo/10);
            if(temporal<80) temporal=80;

            tiempoX=SDL_GetTicks()+temporal;
            tiempo++;

            if(dire!=0)
            {
                cabezaX=Serpiente[0].x;
                cabezaY=Serpiente[0].y;

                for(int z=longitud; z>0; z--)
                {
                    Serpiente[z].x=Serpiente[z-1].x;
                    Serpiente[z].y=Serpiente[z-1].y;
                    Serpiente[z].t=Serpiente[z-1].t;
                }

                switch(dire)
                {
                case up:
                    Serpiente[0].y-=ALTO_P;
                    Serpiente[0].t=up;
                    break;
                case down:
                    Serpiente[0].y+=ALTO_P;
                    Serpiente[0].t=down;
                    break;
                case left:
                    Serpiente[0].x-=ANCHO_P;
                    Serpiente[0].t=left;
                    break;
                case right:
                    Serpiente[0].x+=ANCHO_P;
                    Serpiente[0].t=right;
                    break;
                }
            
             //Comerse a si mismo
                for(int z=1; z<longitud; z++)
                {
                    if(Serpiente[0].x==Serpiente[z].x && Serpiente[0].y==Serpiente[z].y)
                    {
                        Mix_PauseMusic();
                        animarMuerte();
                        puntuar(Puntos);
                        if(1==waitQuit()) goto FinPrograma;  //Salir
                        goto Inicio;
                    }
                }
             // Detecta paredes
                if(Serpiente[0].y<0 || Serpiente[0].x<0 || Serpiente[0].x>WINDOW_W || Serpiente[0].y>WINDOW_H)
                {
                    Mix_PauseMusic();
                    animarMuerte();
                    puntuar(Puntos);
                    if(1==waitQuit()) goto FinPrograma;  //Salir
                    goto Inicio;
                }
             //Comer Manzana
                if(Serpiente[0].y==Manzana[0].y && Serpiente[0].x==Manzana[0].x )
                {
                    Puntos += 10;
                    if((longitud+1)<MAX_SERPIENTE)longitud++;
                    Mix_PlayChannel( -1, acomer4, 0 );
                    Manzana[0].x=rand() % WINDOW_W;
                    Manzana[0].y=rand() % WINDOW_H;
                } 
            }
            printPanta();
        }
    }
FinPrograma:
    //Cerrar todo el SDL
    clean_up();
    Mix_FreeMusic(musique);

    printf("Fin_%s\n",titulo);
    SDL_Delay(400);
    return 0;
}


//____________________FIN____________

void Inicializar(void)
{
    tiempoX=0;
    dire = 0;
    Puntos = 0;
    tiempo=0;
    cabezaX=SERPIENTE_X;
    cabezaY=SERPIENTE_Y;
    longitud=6;
    for(int z=0; z<longitud; z++)
    {
        Serpiente[z].x=SERPIENTE_X;
        Serpiente[z].y=SERPIENTE_Y+z*ALTO_P;
        Serpiente[z].t=up;
    }
    Manzana[0].x=MANZANA_X;
    Manzana[0].y=MANZANA_Y;
}



void paintSerpiente(void)
{
    int z;
    
    for(z=0; z<longitud; z++)
    {
        if(z==0)
        {
            //Cabeza
            // imprixxx(SERPI_CA, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
            switch(dire)
            {
            case up:
                imprixxx(SERPI_CA_UP, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                break;
            case down:
                imprixxx(SERPI_CA_DOWN, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                break;
            case left:
                imprixxx(SERPI_CA_LEFT, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                break;
            case right:
                imprixxx(SERPI_CA_RIGHT, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                break;
            default:
                 imprixxx(SERPI_CA_UP, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                break;
            }
        }
        else
        {
            //Cola
            if(z==(longitud-1))
            {
               //imprixxx(SERPI_CO, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
               switch(Serpiente[z-1].t)
                    {
                    case down:
                        imprixxx(SERPI_CO_UP, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case up:
                        imprixxx(SERPI_CO_DOWN, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case left:
                        imprixxx(SERPI_CO_LEFT, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case right:
                        imprixxx(SERPI_CO_RIGHT, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    default:
                         imprixxx(SERPI_CO_UP, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    }
               
            }
            else
            {
                //cuerpo
                //imprixxx(SERPI_CO, TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                
                if(Serpiente[z].t!=Serpiente[z-1].t)
                {
                     //Angulos
                    //imprixxx(112,16,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                    switch(Serpiente[z].t)
                    {
                    case up:
                        switch(Serpiente[z-1].t)
                        {
                        case right:
                            imprixxx(SERPI_AN_UP,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        case left:
                            imprixxx(SERPI_AN_LEFT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        }
                        break;
                    case down:
                        switch(Serpiente[z-1].t)
                        {
                        case right:
                            imprixxx(SERPI_AN_RIGHT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        case left:
                            imprixxx(SERPI_AN_DOWN,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        }
                        break;
                    case left:
                        switch(Serpiente[z-1].t)
                        {
                        case up:
                            imprixxx(SERPI_AN_RIGHT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        case down:
                            imprixxx(SERPI_AN_UP,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        }
                        break;
                    case right:
                        switch(Serpiente[z-1].t)
                        {
                        case up:
                            imprixxx(SERPI_AN_DOWN,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        case down:
                            imprixxx(SERPI_AN_LEFT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                            break;
                        }
                        break;
                    }

                    
                }
                else
                {
                    switch(Serpiente[z].t)
                    {
                    //Dirección
                    case up:
                        imprixxx(SERPI_TR_UP,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case down:
                        imprixxx(SERPI_TR_DOWN,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case left:
                        imprixxx(SERPI_TR_LEFT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    case right:
                        imprixxx(SERPI_TR_RIGHT,TAMA_XY*Serpiente[z].x, TAMA_XY*Serpiente[z].y, TAMA_XY, TAMA_XY);
                        break;
                    }
                   
                }
            }
        }

    }

}

void Repaint(void)
{
    printPanta();
}

void printPanta(void)
{

    //cls(0,0,0);
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = 0;
    clip[ 0 ].y = 0;
    clip[ 0 ].w = SCREEN_WIDTH;
    clip[ 0 ].h = SCREEN_HEIGHT;
    apply_surfaceB( 0, 0, background, screen, &clip[ 0 ] );
 
    paintSerpiente();
    //manzana
    imprixxx(MANZA_XY, TAMA_XY*Manzana[0].x, TAMA_XY*Manzana[0].y, TAMA_XY, TAMA_XY);
/*
   static char temp[20];
    sprintf(temp, "COOR %d,%d  ", Serpiente[0].x, Serpiente[0].y);
    setcolor(255, 255, 255);
    printc(0,460,temp);
*/
    printPuntos();
    refresco();
}




void animarMuerte(void)
{
    int z,I;

    Mix_PlayChannel( -1, amuerte, 0 );
    for(z=1; z<20; z++)
    {
        for(I = 0; I <= longitud; I++) imprixxx(EXPLO_1,TAMA_XY*Serpiente[I].x, TAMA_XY*Serpiente[I].y, TAMA_XY, TAMA_XY);
        refresco();
        SDL_Delay(100);
        for(I = 0; I <= longitud; I++) imprixxx(EXPLO_2,TAMA_XY*Serpiente[I].x, TAMA_XY*Serpiente[I].y, TAMA_XY, TAMA_XY);
        refresco();
        SDL_Delay(100);
    }
    SDL_Delay(600);
}


void animarInicio(void)
{
    int x;

    cls(0,0,0);
    imprixxx(0,0, 320, 220, ANCHO_P, ALTO_P);

    Mix_PlayChannel( -1,aempezar, 0 );
    for(x=0; x<660; x+=ANCHO_P)
    {
        imprixxx(64,16, x-ANCHO_P,220, ANCHO_P, ALTO_P);
        imprixxx(64,0, x,220, ANCHO_P, ALTO_P);
        refresco();
        SDL_Delay(60);
    }
    for(x=0; x<640; x+=ANCHO_P)
    {
        imprixxx(0,16, x-ANCHO_P,220, ANCHO_P, ALTO_P);
        imprixxx(0,16, x,220, ANCHO_P, ALTO_P);
        imprixxx(112,16, x,220, ANCHO_P, ALTO_P);
        refresco();
        SDL_Delay(60);
    }
    cls(0,0,0);

}



//___________Rutinas basicas___________________
int inkeyM()
{
    int tecla;
    SDL_Delay(100);
    while ( SDL_PollEvent( &event ) )
    {
        switch (event.type)
        {
        case  SDL_KEYUP:
            tecla = event.key.keysym.sym;
            //            printf("Evento Tecla UP  %d \n",tecla);
            if (tecla > 96 && tecla < 123) tecla -= 32;
            return (tecla);
            break;
        case  SDL_QUIT:
            return (27);
            break;
        }
    }
    return (0);
}


int waitQuit(void)
{
    int SimbolKey;
    while(0!=inkeyM()) {}
    while(1)
    {
        SimbolKey=inkeyM();
        //printf("->%i\n",SimbolKey);
        if(SimbolKey==27) return(1);
        if(SimbolKey!=0) return(0);
    }
}
//__________________________________
void imprixxx(int xi, int yi, int xo, int yo, int w, int h)
{
    static SDL_Rect clip[ 1 ];
    clip[ 0 ].x = xi;
    clip[ 0 ].y = yi;
    clip[ 0 ].w = w;
    clip[ 0 ].h = h;
    apply_surfaceB( xo, yo, dots, screen, &clip[ 0 ] );
}



void cls(int r,int g,int b)
{
    SDL_FillRect(screen, 0, SDL_MapRGB(screen->format,r,g,b));
}


void printc(int x, int y, char* temp)
{
    static SDL_Surface *message;
    message = TTF_RenderText_Solid( font, temp, ColorDefault );
    apply_surface( x, y, message, screen );
    SDL_FreeSurface(message);
}

void printn(int x, int y, long temp)
{
    char VARI[20];
    sprintf(VARI, "%d", (int)temp);
    printc(x, y, VARI);
}

void impri(int x, int y, char c)
{
    char VARI[20];
    sprintf(VARI, "%c", c);
    printc(x, y, VARI);
}



/* -------------------------- LEE CADENA DEL TECLADO ----*/

char *inputc(int x, int y)
{

    int zz, n;
    static char VARI[20];

    setcolor(0, 100, 0);
    bar(x, y, x + 100, y + 20);
    setcolor(255, 255, 255);
    refresco();
    for(zz=0; zz<10; zz++) inkeyM();

    n = 0;
    zz = 0;
    while (zz != 10)
    {
        zz = inkeyM();
        if (zz == 13 || zz == 27) goto fin;
        if (zz != 0)
        {
            setcolor(0, 100, 0);
            bar(x, y, x + 100, y + 20);
            setcolor(255, 255, 255);
            if (zz == 8)
            {
                n--;
                if (n < 0)n = 0;
                VARI[n] = 0;
            }
            else
            {
                VARI[n] = zz;
                VARI[n + 1] = 0;
                if (n < 6)n++;
            }
            printc(x, y, VARI);
            //        printf("%s\n",VARI);
            refresco();
        }
    }
fin:
    VARI[n] = 0;
    return (VARI);
}

